SystemOrganization addCategory: #'Mercury-Ide'!

PluggableListItemWrapper subclass: #MercuryTreeItem
	instanceVariableNames: 'icon contents info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Ide'!

!MercuryTreeItem class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 10:55'!
newFromAssociation: anAssociation withIcon: anIcon

	^ self new
		item: anAssociation key;
		contents: anAssociation value;
		withIcon: anIcon.! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 10:57'!
contents

	^ contents! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 10:57'!
contents: aCollectionOfTreeItems

	contents := aCollectionOfTreeItems ! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 14:24'!
icon

	^ icon! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 10:57'!
item

	^ item! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 10:58'!
item: aString 

	item := aString! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 11:20'!
metaInfo

	^ info! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 11:20'!
metaInfo: anObject 

	info := anObject! !

!MercuryTreeItem methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 13:57'!
withIcon: aForm 
	icon := aForm! !

Object subclass: #MercuryIDE
	instanceVariableNames: 'window environmentMirrors tabGroup tab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Ide'!

!MercuryIDE methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/28/2012 14:19'!
buildRowWithImage: anImageFilename andLabel: labelText

	 ^ window newRow: {
		window newImage: (Form fromFileNamed: self resourcesDirectory , anImageFilename).
		(window newLabel: labelText)
	}! !

!MercuryIDE methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2012 14:05'!
buildUI

	window := StandardWindow new.
	
	tab := (MercuryIdeEnvironmentTab new openWithEnvironmentMirror: (environmentMirrors at: 1)). 
	
	tabGroup :=  window newTabGroup: {
		 (self buildRowWithImage: 'environment.png' andLabel: 'a Local Environment' ) -> (MercuryIdeEnvironmentTab new openWithEnvironmentMirror: (environmentMirrors at: 1)).
		"  (self buildRowWithImage: 'environment.png' andLabel: 'a Remote Environment' ) -> Morph new."
		(window newImage: (Form fromFileNamed: self resourcesDirectory , 'add.png')) -> Morph new.}.
		
	window addMorph: tabGroup frame: (0@0 corner: 1@1).
	
	tabGroup color: window color.
	
	window title: 'Mercury I.D.E.';
		openInWorld; 
		fullscreen.! !

!MercuryIDE methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/25/2012 10:51'!
initialize 

	environmentMirrors := OrderedCollection new.! !

!MercuryIDE methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/25/2012 10:54'!
openWithEnvironmentMirror: anEnvironementMirror

	environmentMirrors add: anEnvironementMirror.
	
	self buildUI ! !

!MercuryIDE methodsFor: 'resources' stamp: 'NickPapoulias 2/19/2013 10:41'!
resourcesDirectory

	^ '/home/wnlt/Desktop/MercuryIDE_resources/'! !

Object subclass: #MercuryIdeEnvironmentTab
	instanceVariableNames: 'morphs layout environmentMirror uiModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury-Ide'!

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-source' stamp: 'NickPapoulias 4/5/2013 16:25'!
acceptSource: sourceCode

	|resultMirror selector|
	
	selector := nil.
	resultMirror := nil.

	(uiModel at: #selectedProtocol) ifNotNil: [
		selector := self compileMethodWithSource: sourceCode asString inClassNamed: (uiModel at: #selectedClass) item.
	] ifNil: [
		(uiModel at: #selectedClass) ifNotNil: [
			resultMirror := self evaluateSourceCode: sourceCode asString.
		]
	].

	selector ifNotNil: [
	
			|selectedMethod|
			
			self changed: #methodsHierarchy.
			selectedMethod := ((uiModel at: #methods) select: [:methodItem | methodItem item = selector asString]) first.
			self selectedMethod: selectedMethod.
			
	] ifNil: [
			resultMirror ifNotNil: [
				(resultMirror isKindOf: ClassIntrospectionMirror) ifTrue: [
				
					|selectedClass className|
				
					self changed: #classHierarchy.
					className := resultMirror systemName asString.
					selectedClass := ((uiModel at: #classes) select: [:classItem | classItem item = className]) first.
					self selectedClass: selectedClass.				
				].
			].
	]! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 10:47'!
allClassNamesForPackage: aPackageName

	^ (environmentMirror packageNamed: aPackageName) classes! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 11:39'!
allMethodNamesForProtocol: aProtocolName inClass: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) methodsInProtocol: aProtocolName ! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 12:12'!
allMethodNamesInClass: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) methodNames! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 10:45'!
allPackageNames

	^ environmentMirror packageNames! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-environment' stamp: 'NickPapoulias 6/21/2012 13:13'!
allProcesses

	^ #()! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 10:54'!
allProtocolNamesForClass: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) protocols.
	
	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-protocols' stamp: 'NickPapoulias 6/20/2012 12:51'!
allProtocols

	^ #(accessing initialize)




	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 6/21/2012 14:36'!
allTestsForPackage

	^#()! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-classes' stamp: 'NickPapoulias 7/2/2012 12:57'!
buildClassesMorph

	morphs at: #classesListingMorph put: ((morphs at: #window) newTreeFor: self
				list: #classHierarchy
				selected: #selectedClass
				changeSelected: #selectedClass:).

	morphs at: #classesMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'class.png' andLabel: 'Classes') -> (morphs at: #classesListingMorph)								
	}).



	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-console' stamp: 'NickPapoulias 7/13/2012 11:23'!
buildContextConsoleMorph

		
		morphs at: #console put: (((morphs at: #window) newTextEditorFor: self  getText: #consoleText  setText: #consoleText:) acceptOnCR: true;
	acceptAction: [:contents | self consoleAccept: contents]). 

          morphs at: #consoleMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'console.png' andLabel: 'Context Console') -> (morphs at: #console)
		}).

	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-context-inspector' stamp: 'NickPapoulias 7/2/2012 10:37'!
buildContextInspectorMorph


		morphs at: #cInspectorMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'data.png' andLabel: 'Context Inspector') ->
				((morphs at: #window) newPanel
					layoutPolicy: RowLayout new;
					addMorph: ((morphs at: #window) newListFor: self list: #ctxVarValues selected: nil  changeSelected: nil  help: nil);
					addMorph: ((morphs at: #window) newListFor: self list: #ctxVarNames selected: nil  changeSelected: nil  help: nil)
					
				).

		}).
! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-debug' stamp: 'NickPapoulias 10/1/2012 14:18'!
buildDebugMorph

          morphs at: #debugMorph put: (((morphs at: #window) newPanel) 
				layoutPolicy: RowLayout new;
				addMorph: (((morphs at: #window) newTextEntryFor: self getText:  nil setText: #runDebug: help: '')hResizing: #spaceFill;yourself);
				addMorph: ((self buildRowWithImage: 'debug.png' andLabel: 'Run/Debug: ' ) hResizing: #shrinkWrap);
				addMorph: ((morphs at: #window) newButtonFor: self  action: #through label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'through.png')) help: '');
				addMorph: ((morphs at: #window) newButtonFor: self  action: #over label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'fast_forward.png')) help: '');
				addMorph: ((morphs at: #window) newButtonFor: self  action: #into label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'forward.png')) help: '');
				addMorph: ((morphs at: #window) newButtonFor: self  action: #stopSelectedProcess label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'stop.png')) help: '');
				addMorph: ((morphs at: #window) newButtonFor: self  action: #interuptSelectedProcess label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'pause.png')) help: '');
				addMorph: ((morphs at: #window) newButtonFor: self  action: #proceed label: ((morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , 'play.png')) help: '');
				addMorph: ((self buildRowWithImage: 'debug.png' andLabel: 'Debug: ' ) hResizing: #shrinkWrap)).! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-environment' stamp: 'NickPapoulias 7/2/2012 10:29'!
buildEnvironmentMorph

	morphs at: #environmentMorph put:  ((morphs at: #window) newTabGroup: { self buildPackagesMorph. self buildProcessMorph. self buildExceptionsMorph}).! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-exceptions' stamp: 'NickPapoulias 4/8/2013 12:11'!
buildExceptionsMorph
	^ (self buildRowWithImage: 'exception.png' andLabel: 'Exceptions' )
		->
			((morphs at: #window) newPanel
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				addMorph:
						((morphs at: #window)
								newTabGroup:
									{('Stack'
										->
											((morphs at: #window)
												newTreeFor: self
												list: #stack
												selected: #selectedContext
												changeSelected: #selectedContext:
											))});
				addMorph:
						((morphs at: #window)
								newTreeFor: self
								list: #exceptions
								selected: #selectedException
								changeSelected: #selectedException:
						))! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-methods' stamp: 'NickPapoulias 7/2/2012 13:58'!
buildMethodsMorph

          morphs at: #methodsMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'method.png' andLabel: 'Methods') ->
				((morphs at: #window) newTreeFor: self
				list: #methodsHierarchy
				selected: #selectedMethod
				changeSelected: #selectedMethod:).
		}).


	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-environment' stamp: 'NickPapoulias 7/2/2012 11:21'!
buildPackagesMorph

	morphs at: #packagesMorph put: ((morphs at: #window)
				newTreeFor: self
				list: #packageHierarchy
				selected: #selectedPackage
				changeSelected: #selectedPackage:).
	
	^ (self buildRowWithImage: 'package.png' andLabel: 'Packages' ) -> (morphs at: #packagesMorph) 
	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-environment' stamp: 'NickPapoulias 6/28/2012 14:16'!
buildProcessMorph
	^  (self buildRowWithImage: 'process.png' andLabel: 'Processes' )
		->
			((morphs at: #window) newPanel
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				addMorph:
						((morphs at: #window)
								newTabGroup:
									{('Stack'
										->
											((morphs at: #window)
												newListFor: self
												list: #stackForProcess
												selected: nil
												changeSelected: nil
												help: nil))});
				addMorph:
						((morphs at: #window)
								newListFor: self
								list: #allProcesses
								selected: nil
								changeSelected: nil
								help: nil))! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-protocols' stamp: 'NickPapoulias 7/2/2012 16:58'!
buildProtocolsMorph

	morphs at: #protocolsMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'protocol.png' andLabel: 'Protocols') ->
				((morphs at: #window) newTreeFor: self
				list: #protocolsHierarchy
				selected: #selectedProtocol
				changeSelected: #selectedProtocol:).
		}).




	! !

!MercuryIdeEnvironmentTab methodsFor: 'utilities' stamp: 'NickPapoulias 6/28/2012 14:12'!
buildRowWithImage: anImageFilename andLabel: labelText

	 ^ (morphs at: #window) newRow: {
		(morphs at: #window) newImage: (Form fromFileNamed: self resourcesDirectory , anImageFilename).
		((morphs at: #window) newLabel: labelText)
	}! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-search' stamp: 'NickPapoulias 7/2/2012 10:29'!
buildSearchMorph

	morphs at: #searchMorph put: ((morphs at: #window) newLabelGroup: {
		 (self buildRowWithImage: 'search.png' andLabel: 'Search: ' ) -> 
			((morphs at: #window) newTextEntryFor: (ValueHolder new contents: '') getText: #contents setText: nil help: '')
		}).

	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-self-inspector' stamp: 'NickPapoulias 7/2/2012 10:36'!
buildSelfInspectorMorph 

	morphs at: #sInspectorMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'data_fields.png' andLabel: 'Object Inspector') ->
				((morphs at: #window) newPanel
					layoutPolicy: RowLayout new;
					addMorph: ((morphs at: #window) newListFor: self list: #selfInstVarValues selected: nil  changeSelected: nil  help: nil);
					addMorph: ((morphs at: #window) newListFor: self list: #selfInstVarNames selected: nil  changeSelected: nil  help: nil)
					
				).
		}).
! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-source' stamp: 'NickPapoulias 7/9/2012 12:04'!
buildSourceMorph


		morphs at: #sourceMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'source.png' andLabel: 'Code') ->
				((((morphs at: #window) newTextEditorFor: self  getText: #sourceCode  setText: #sourceCode:)) acceptAction: [:source | self acceptSource: source])
		}).



	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 7/2/2012 10:34'!
buildToolsMorph 

	morphs at: #toolsMorph put: ((morphs at: #window) newTabGroup: {
				(self buildRowWithImage: 'test.png' andLabel: 'Tests') ->
					((morphs at: #window) newPanel 
						layoutPolicy: TableLayout new;
						listDirection: #topToBottom;
						addMorph: ((morphs at: #window) newTabGroup: {'Results'-> ((morphs at: #window) newListFor: self list: #resultsForTests selected: nil  changeSelected: nil  help: nil)});
						addMorph: ((morphs at: #window) newListFor: self list: #allTestsForPackage selected: nil  changeSelected: nil  help: nil)).
				(self buildRowWithImage: 'measurement.png' andLabel: 'Profile') ->((morphs at: #window) newPanel 
						layoutPolicy: TableLayout new;
						listDirection: #topToBottom;
						addMorph: ((morphs at: #window) newTabGroup: {'Results'-> ((morphs at: #window) newListFor: self list: #resultsForProfiling selected: nil  changeSelected: nil  help: nil)});
						addMorph: (((morphs at: #window) newPanel) 
								layoutPolicy: RowLayout new;
								addMorph: ((morphs at: #window) newTextEntryFor: (ValueHolder new contents: 'asdf') getText:  #contents setText: nil help: '');
								addMorph: ((morphs at: #window) newLabel: 'Profile: ');
								hResizing:#spaceFill)).
				(self buildRowWithImage: 'folder.png' andLabel: 'Versioning') ->((morphs at: #window) newPanel
									layoutPolicy: TableLayout new;
									listDirection: #topToBottom;
									addMorph: ((morphs at: #window ) newTabGroup: {'Repositories'-> ((morphs at: #window) newListFor: self list: #repositoriesForPackage selected: nil  changeSelected: nil  help: nil).});
									addMorph: ((morphs at: #window ) newTabGroup: {'Versions'-> ((morphs at: #window) newListFor: self list: #versionsForPackageInRepository selected: nil  changeSelected: nil  help: nil)})).
				(self buildRowWithImage: 'documentation.png' andLabel: 'Documentation') ->((morphs at: #window) newTextEntryFor: self getText: #documentationForClass setText: nil help:'').
				}).
	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui' stamp: 'NickPapoulias 7/2/2012 10:38'!
buildUI

	self buildWindowMorph.
	self buildSearchMorph .
	self buildEnvironmentMorph.
	self buildClassesMorph .
	self buildProtocolsMorph .
	self buildMethodsMorph .
	self buildDebugMorph .
	self buildSourceMorph .
	self buildToolsMorph .
	self buildContextConsoleMorph .
	self buildSelfInspectorMorph .
	self buildContextInspectorMorph .

	layout keys do: [:aMorphName |
			(morphs at: #window) addMorph: (morphs at: aMorphName) frame: (layout at: aMorphName).
			(morphs at: aMorphName) color: (morphs at: #window) color.	
	].

	(morphs at: #window)
			beWithoutGrips;
			removeLabelArea;
			makeBorderless.
			
	^ morphs at: #window.
! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-window' stamp: 'NickPapoulias 7/2/2012 10:38'!
buildWindowMorph

	morphs at: #window put: StandardWindow new! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-classes' stamp: 'NickPapoulias 7/5/2012 10:34'!
classHierarchy

	(uiModel at: #selectedPackage) isNil ifFalse: [
		
		((uiModel at: #selectedPackage) metaInfo at: #isPackage) ifTrue: [
			"mirror access"
			uiModel at: #classes put: ((self allClassNamesForPackage: (uiModel at: #selectedPackage) item) collect: [:classOrTraitName |
				(MercuryTreeItem newFromAssociation: (classOrTraitName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'class.png')) metaInfo: {} asDictionary	
			])
		
		] ifFalse: [
		
			uiModel at: #classes put: #().
		
		]
	
	] ifTrue: [
	
		uiModel at: #classes put: #().
	
	].

	((uiModel at: #classes) isEmpty) ifFalse: [
		uiModel at: #selectedClass put: (uiModel at: #classes) first.
		uiModel at: #sourceCode put: (self definitionForClassNamed: (uiModel at: #selectedClass) item).
	] ifTrue: [
		uiModel at: #selectedClass put: nil.
		uiModel at: #sourceCode put: ''.
	].
	
	^ uiModel at: #classes.! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 13:30'!
compileMethodWithSource: methodSource inClassNamed: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) addMethod: methodSource.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-console' stamp: 'NickPapoulias 2/19/2013 14:04'!
consoleAccept: contents

	((uiModel at: #consoleInput) = '') ifFalse: [
		|resultMirror|
		resultMirror := self evaluateExpression: (uiModel at: #consoleInput).
		uiModel at: #consoleInput put: ''.
		uiModel at: #consoleText put: ((uiModel at: #consoleText) , Character cr asString , '>>> ' , resultMirror objAsString , Character cr , 'Workspace >>> ').
		self changed: #consoleText.
		"move cursor to the end"
	]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-console' stamp: 'NickPapoulias 7/10/2012 13:17'!
consoleText


	^ uiModel at: #consoleText
	! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-console' stamp: 'NickPapoulias 7/10/2012 15:31'!
consoleText: aString
	
	|input|
	
	input := ''.
	
	(aString size <= (uiModel at: #consoleText) size) ifTrue: [
		(uiModel at: #consoleText) put: (uiModel at: #consoleText) , Character cr asString , 'Workspace >>> '. 
	] ifFalse: [	
		(uiModel at: #consoleText) size to: aString size do: [:index |
			input := input , (aString at: index) asString			
		].
		uiModel at: #consoleText put: aString.
		uiModel at: #consoleInput put: input.
	].
	! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-context-inspector' stamp: 'NickPapoulias 6/21/2012 12:19'!
ctxVarNames

	^ #('thisContext' 'stackTop' 'all temp vars' 'x' 'y').! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-context-inspector' stamp: 'NickPapoulias 6/21/2012 12:20'!
ctxVarValues

	^ #().! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 10:50'!
definitionForClassNamed: aClassName

	^ (environmentMirror globalAt: aClassName asSymbol) definition! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 6/21/2012 16:05'!
documentationForClass

	^ ''

! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 14:20'!
evaluateExpression: expression

	^ environmentMirror evaluate: expression onRemoteExceptionDo: [:anExceptionMirror | ] "will be notified"! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 14:21'!
evaluateSourceCode: classCreationSource

	^ environmentMirror evaluate: classCreationSource onRemoteExceptionDo: [:anExceptionMirror | ] "should show up in the exceptions"! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 4/8/2013 13:36'!
exceptions

	"mirror access"
	|exceptions|
	exceptions := self unhandledExceptionDescriptions.
	
	exceptions doWithIndex: [:item :index |
		(uiModel at: #exceptions)
			add: ((MercuryTreeItem newFromAssociation: (item -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'exception.png')) metaInfo: {#index -> index} asDictionary) 	
	].
	
	uiModel at: #selectedException put: nil.
	
	^ uiModel at: #exceptions.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 10/1/2012 13:29'!
fullstack

	self halt! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 10/1/2012 13:29'!
goToStackIndex: anIndexNumber

	self halt! !

!MercuryIdeEnvironmentTab methodsFor: 'initialize' stamp: 'NickPapoulias 4/8/2013 11:40'!
initialize

	morphs := Dictionary new.
	uiModel := Dictionary new.
	environmentMirror := nil.
	layout := self layout.
	uiModel := {#packages-> #() .
				#selectedPackage -> nil.
				#classes -> #().
				#selectedClass -> nil.
				#protocols -> #().
				#selectedProtocol -> nil.
				#methods -> #().
				#selectedMethod -> nil.
				#sourceCode -> '' .
				#consoleText -> 'Workspace >>> '.
				#consoleInput -> '' .
				#exceptions -> #().
				#selectedException -> nil.
				#stack -> #().
				#selectedContext -> nil.} asDictionary ! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 10/1/2012 13:34'!
interuptSelectedProcess

	self halt! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 10/1/2012 13:29'!
into

	self halt! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-layout' stamp: 'NickPapoulias 6/28/2012 13:10'!
layout

	^   {#searchMorph -> (0@0 corner: 1@0.04) .
		#environmentMorph -> (0@0.04 corner: 0.25@1) .
		#classesMorph -> (0.25@0.04 corner: 0.42@0.32) .
		#protocolsMorph -> (0.42@0.04 corner: 0.58@0.32) .
		#methodsMorph -> (0.58@0.04 corner: 0.75@0.32) .
		#debugMorph -> (0.25@0.32 corner: 0.75@0.38).
		#sourceMorph -> (0.25@0.38 corner: 0.75@0.80) .
		#toolsMorph -> (0.75@0.04 corner: 1@0.80) .
		#consoleMorph -> (0.25@0.80 corner: 0.70@1) .
		#sInspectorMorph -> (0.70@0.80 corner: 0.85@1).
		#cInspectorMorph -> (0.85@0.80 corner: 1@1) .} asDictionary. ! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-methods' stamp: 'NickPapoulias 7/9/2012 14:59'!
methodsHierarchy


	((uiModel at: #selectedClass) isNil not & (uiModel at: #selectedProtocol) isNil not) ifTrue: [
			"mirror access"
			
			((uiModel at: #selectedProtocol) item = '---all---') ifTrue: [
				uiModel at: #methods put:  (((self allMethodNamesInClass: (uiModel at: #selectedClass) item)) collect: [:methodName |
					(MercuryTreeItem newFromAssociation: (methodName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'method.png')) metaInfo: {} asDictionary	
				]).
				uiModel at: #selectedMethod put: #(). "(uiModel at: #methods) first." "do not select method by default"	
			] ifFalse: [
			
				uiModel at: #methods put:  (((self allMethodNamesForProtocol: (uiModel at: #selectedProtocol) item inClass: (uiModel at: #selectedClass) item)) collect: [:methodName |
					(MercuryTreeItem newFromAssociation: (methodName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'method.png')) metaInfo: {} asDictionary	
				]).
				uiModel at: #selectedMethod put: nil. "(uiModel at: #methods) first." "do not select method by default"	
			]
	] ifFalse: [
			uiModel at: #selectedMethod put: nil.
			uiModel at: #methods put: #().
	].

	(uiModel at: #selectedClass) ifNotNil: [
		uiModel at: #sourceCode put: (self definitionForClassNamed: (uiModel at: #selectedClass) item)
	] ifNil: [
		uiModel at: #sourceCode put: ''
	].

	^ uiModel at: #methods.! !

!MercuryIdeEnvironmentTab methodsFor: 'open' stamp: 'NickPapoulias 4/8/2013 12:42'!
openWithEnvironmentMirror: anEnvironementMirror

	|ui|

	environmentMirror := anEnvironementMirror.
	ui := self buildUI.
	self registerExceptionCallback.
	^ ui.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 10/1/2012 13:29'!
over

	self halt! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 6/29/2012 13:52'!
packageFamiliesFor: packageNames 
	
	^ (packageNames collect: [:aPackageName | (aPackageName findTokens: '-') at: 1]) asSet! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 7/4/2012 11:29'!
packageHierarchy

	|packageNames treeItemCollection packageFamilies|
	
	(uiModel at: #packages) isEmpty ifFalse: [^ uiModel at: #packages]. 

	packageNames := self allPackageNames. "mirror access"
	
	packageFamilies := (self packageFamiliesFor: packageNames) asOrderedCollection sort: [:a :b | a < b].

	treeItemCollection := OrderedCollection new.

	packageFamilies do: [:aPackageFamilyName |
		
		|packagesOfPackageFamily packagesAssociation|
		
		packagesOfPackageFamily := (self packagesOfPackageFamily: aPackageFamilyName in: packageNames) sort: [:a :b | a < b].
		
		packagesAssociation := (aPackageFamilyName-> (packagesOfPackageFamily collect: [:aPackageName |
			(MercuryTreeItem newFromAssociation: (aPackageName -> #()) withIcon:  (Form fromFileNamed: self resourcesDirectory , 'package.png')) metaInfo: {#isPackage -> true} asDictionary.
		])).
		
		treeItemCollection add: ((MercuryTreeItem newFromAssociation: packagesAssociation withIcon: (Form fromFileNamed: self resourcesDirectory , 'package.png')) metaInfo: {#isPackage -> false} asDictionary). 
				
	]. 

	uiModel at: #packages put: treeItemCollection.
	
	uiModel at: #selectedPackage put: treeItemCollection first.

	^ treeItemCollection ! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 6/29/2012 14:00'!
packagesOfPackageFamily: aPackageFamilyName in: packageNames

	^ packageNames select: [:packageName | (packageName size >= aPackageFamilyName size) ifTrue: [ ((packageName copyFrom: 1 to: (aPackageFamilyName size)) = aPackageFamilyName)] ifFalse: [ false ] ].! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 10/1/2012 13:29'!
proceed

	self halt! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-protocols' stamp: 'NickPapoulias 7/9/2012 16:59'!
protocolsHierarchy

	((uiModel at: #selectedClass)) isNil ifFalse: [
			"mirror access"
			uiModel at: #protocols put: ((self allProtocolNamesForClass: (uiModel at: #selectedClass) item) collect: [:protocolName |
				(MercuryTreeItem newFromAssociation: (protocolName -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'protocol.png')) metaInfo: {} asDictionary	
			]).
			(uiModel at: #protocols) addFirst: (MercuryTreeItem newFromAssociation: ('---all---' -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'protocol.png')).	
	] ifTrue: [
		
			uiModel at: #protocols put: #() asOrderedCollection 
		
	].

	uiModel at: #selectedProtocol put: nil.
	
	^ uiModel at: #protocols.! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/8/2013 12:42'!
registerExceptionCallback 

	environmentMirror onRemoteExceptionDo: [:remoteEx | self changed: #exceptions].! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 6/21/2012 16:05'!
repositoriesForPackage

	^ #()

! !

!MercuryIdeEnvironmentTab methodsFor: 'resources' stamp: 'NickPapoulias 2/19/2013 10:41'!
resourcesDirectory

	^ '/home/wnlt/Desktop/MercuryIDE_resources/'! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 10/1/2012 13:29'!
restart

	self halt! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 6/21/2012 14:52'!
resultsForProfiling

	^ #()

! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 6/21/2012 14:35'!
resultsForTests

	^#()! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 10/1/2012 12:35'!
runDebug: aString

	self halt! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 10/1/2012 13:30'!
runToHere: anIntervalAsString

	self halt! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-classes' stamp: 'NickPapoulias 7/3/2012 13:05'!
selectedClass

	^ uiModel at: #selectedClass ifAbsent: [nil]
! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-classes' stamp: 'NickPapoulias 7/5/2012 10:35'!
selectedClass: aClassItem

	uiModel at: #selectedClass put: aClassItem.
	uiModel at: #sourceCode put: (self definitionForClassNamed: (uiModel at: #selectedClass) item).
	self changed: #selectedClass.
	self changed: #protocolsHierarchy.
	self changed: #methodsHierarchy.
	self changed: #sourceCode.
	! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 4/8/2013 11:56'!
selectedContext

	^ uiModel at: #selectedContext ifAbsent: [nil]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 4/8/2013 12:00'!
selectedContext: anItem

	uiModel at: #selectedContext put: anItem.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 4/8/2013 11:46'!
selectedException

	^ uiModel at: #selectedException ifAbsent: [nil]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 4/8/2013 11:55'!
selectedException: anItem

	uiModel at: #selectedException put: anItem.
	self changed: #selectedException.
	self changed: #stack.! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-methods' stamp: 'NickPapoulias 7/2/2012 16:52'!
selectedMethod

	^ uiModel at: #selectedMethod ifAbsent: [nil]
! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-methods' stamp: 'NickPapoulias 7/3/2012 11:45'!
selectedMethod: aMethodItem

	uiModel at: #selectedMethod put: aMethodItem.
	uiModel at: #sourceCode put: (self sourceCodeForMethodNamed: aMethodItem item inClassNamed: (uiModel at: #selectedClass) item).
	self changed: #selectedMethod.
	self changed: #sourceCode.
	! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 7/3/2012 13:04'!
selectedPackage

	^ uiModel at: #selectedPackage ifAbsent: [ nil]
! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-packages' stamp: 'NickPapoulias 7/3/2012 11:44'!
selectedPackage: aPackageItem

	uiModel at: #selectedPackage put: aPackageItem.
	self changed: #selectedPackage.
	self changed: #classHierarchy.
	self changed: #protocolsHierarchy.
	self changed: #methodsHierarchy.
	self changed: #sourceCode.
	"(morphs at: #classesListingMorph) update: #classHierarchy."! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-protocols' stamp: 'NickPapoulias 7/3/2012 13:05'!
selectedProtocol

	^ uiModel at: #selectedProtocol ifAbsent: [nil]! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-protocols' stamp: 'NickPapoulias 7/3/2012 13:06'!
selectedProtocol: aProtocolItem

	uiModel at: #selectedProtocol put: aProtocolItem.
	self changed: #selectedProtocol.
	self changed: #methodsHierarchy.
	self changed: #sourceCode.! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-self-inspector' stamp: 'NickPapoulias 6/21/2012 12:20'!
selfInstVarNames

	^ #('self' 'all inst vars' 'x' 'y')
! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-self-inspector' stamp: 'NickPapoulias 6/21/2012 12:20'!
selfInstVarValues

	^ #()
! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-source' stamp: 'NickPapoulias 7/3/2012 11:35'!
sourceCode

	^ uiModel at: #sourceCode ifAbsent: ['']! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-source' stamp: 'NickPapoulias 7/3/2012 11:07'!
sourceCode: aString

	uiModel at: #sourceCode put: aString.
	self changed: #sourceCode.! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 2/19/2013 12:07'!
sourceCodeForMethodNamed: aMethodName inClassNamed: aClassName

	^ ((environmentMirror globalAt: aClassName) methodAt: aMethodName asSymbol) source 
! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-exceptions' stamp: 'NickPapoulias 4/8/2013 13:53'!
stack

	(uiModel at: #selectedException) isNil ifFalse: [
		
		|stack|
		stack := self stackForException: (((uiModel at: #selectedException)) metaInfo at: #index).
	
		stack doWithIndex: [:item :index |
			(uiModel at: #stack)
				add: ((MercuryTreeItem newFromAssociation: (item -> #()) withIcon: (Form fromFileNamed: self resourcesDirectory , 'method.png')) metaInfo: {#index -> index} asDictionary) 	
		].
		
	] ifTrue: [
	
		uiModel at: #stack put: #().
	
	].
	
	^ uiModel at: #stack.! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/8/2013 14:05'!
stackForException: anIndex

	^ (environmentMirror unhandledExceptions at: anIndex) interruptedProcess stack collect: [:contextMirror | contextMirror objAsString]! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-environment' stamp: 'NickPapoulias 6/21/2012 13:13'!
stackForProcess

	^ #()! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 10/1/2012 13:33'!
stopSelectedProcess

	self halt! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 10/1/2012 13:30'!
through

	self halt! !

!MercuryIdeEnvironmentTab methodsFor: 'mirror-model-access' stamp: 'NickPapoulias 4/8/2013 13:00'!
unhandledExceptionDescriptions

	^ environmentMirror unhandledExceptions collect: [:exceptionMirror | exceptionMirror description]! !

!MercuryIdeEnvironmentTab methodsFor: 'build-ui-tools' stamp: 'NickPapoulias 6/21/2012 16:04'!
versionsForPackageInRepository

	^ #()

! !

!MercuryIdeEnvironmentTab methodsFor: 'ui-model-access-debugger' stamp: 'NickPapoulias 10/1/2012 13:30'!
where

	self halt! !
